;The G.E.C.K. PowerUp for New Vegas loader
;Loader version 0.6
;Written by Fedor Uvarov, 2010
;Patched for G.E.C.K 1.3 by H. LE PORS, 19 JULY 2011

;This source code is compilable with Flat Assembler (http://flatassmebler.net)
;I use version 1.69.25 (patched with 1.69.31 available at the time)
;Please note that there is a certain bug in FASM include files, on which this source may be dependent
;(namely, MENUITEMINFO definition). This will be fixed in PowerUp 0.2.0 by redifining this structure.

format PE GUI 4.0

entry start

include 'win32a.inc'

NEED_NVSE equ 0 ;0 to not load NVSE, 1 to load

NEEDED_LIB_VERSION equ 6	;0.1.6, 0.1.7
EXIT_OK equ 0
EXIT_NOGECK equ 1
EXIT_NOALLOC equ 2
EXIT_NOWRITE equ 3
EXIT_NOCHANGEENTRY equ 4
EXIT_WRONGLIB equ 5
EXIT_NOMODNAME equ 6
EXIT_NOFULLPATH equ 7
EXIT_NOSETCURDIR equ 8
EXIT_NOSETPROTECTION equ 9
INFINITE equ -1
LANG = LANG_ENGLISH + SUBLANG_DEFAULT

;;;; 1.3 ;;;; ;Entry point address: 00C61C11, original code: E8 6E450100 (call 00C76184)
;;;; 1.3 ;;;; ORIGINAL_ENTRY_POINT equ 00C61C11h
;;;; 1.3 ;;;; ORIGINAL_ENTRY_CALL equ 00C76184h
;;;; 1.3 ;;;; ORIGINAL_ENTRY_CALL_OFFSET equ 0001456Eh        ;At the entry point the code is: 0E8h ORIGINAL_ENTRY_CALL_OFFSET

;;;; 1.4 ;;;; ;Entry point address: 00C61C11, original code: E8 6E450100 (call 00C76184)
;;;; 1.4 ;;;; ORIGINAL_ENTRY_POINT equ 00C62B61h
;;;; 1.4 ;;;; ORIGINAL_ENTRY_CALL equ 00C77023h
;;;; 1.4 ;;;; ; ORIGINAL_ENTRY_CALL_OFFSET = ORIGINAL_ENTRY_CALL - ORIGINAL_ENTRY_POINT - 5 (size of call instruction)
;;;; 1.4 ;;;; ; ORIGINAL_ENTRY_CALL_OFFSET = 00C77023h - 00C62B61h - 5 = 000144BDh
;;;; 1.4 ;;;; ORIGINAL_ENTRY_CALL_OFFSET equ 000144BDh        ;At the entry point the code is: 0E8h ORIGINAL_ENTRY_CALL_OFFSET

;Entry point address: 00C61C11, original code: E8 6E450100 (call 00C76184)
ORIGINAL_ENTRY_POINT equ 00C62C31h
ORIGINAL_ENTRY_CALL equ 00C770F3h
; ORIGINAL_ENTRY_CALL_OFFSET = ORIGINAL_ENTRY_CALL - ORIGINAL_ENTRY_POINT - 5 (size of call instruction)
; ORIGINAL_ENTRY_CALL_OFFSET = 00C770F3h - 00C62C31h - 5 = 000144BDh
ORIGINAL_ENTRY_CALL_OFFSET equ 000144BDh	;At the entry point the code is: 0E8h ORIGINAL_ENTRY_CALL_OFFSET

struct SECURITY_ATTRIBUTES
	nLength dd ?
	lpSecurityDescriptor dd ?
	bInheritHandle dd ?
ends


section '.data.' data readable writeable
GECKFileName db 'geck.exe', 0
ErrorCaption db 'Error!', 0
ErrorNoGECK db 'Could not load geck.exe', 0
ErrorNoAlloc db 'Could not allocate memory within the GECK process', 0
ErrorNoCleanup db "Proper cleanup may not have been done! Terminate GECK if it's still running.", 0
ErrorNoWrite db 'Could not inject code into the memory of the GECK process', 0
ErrorNoChangeEntry db "Could not replace the code at GECK's entry point. Strange.", 0
ErrorWrongLib db 'Wrong library version! Please reinstall the PowerUp.', 0
ErrorInternalNoModuleName db "Internal error: cannot get current module path. It's weird.", 0
ErrorInternalNoFullPath db "Internal error: cannot get full path to current module. It's weird.", 0
ErrorInternalNoSetCurDir db "Internal error: cannot set current directory", 0
ErrorNoSetProtection db "Cannot change protection on GECK's memory", 0
pGeckMem dd ?
GECKProcessInfo PROCESS_INFORMATION
db sizeof.PROCESS_INFORMATION
OurStartupInfo STARTUPINFO
db sizeof.STARTUPINFO
ThreadSecurityAttributes SECURITY_ATTRIBUTES
db sizeof.SECURITY_ATTRIBUTES
OldProtection dd ?


section '.code' code readable executable
start:
;Finding self and setting current directory there
;It will be done by GECK anyway.
sub esp, 2*MAX_PATH + 4
mov eax, esp
add eax, 4
invoke GetModuleFileName, 0, eax, 2*MAX_PATH
test eax, eax
jnz got_path

invoke MessageBoxEx, 0, ErrorInternalNoModuleName, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke ExitProcess, EXIT_NOMODNAME

got_path:
mov eax, esp
add eax, 4
mov ecx, eax
add eax, MAX_PATH
invoke GetFullPathName, ecx, MAX_PATH, eax, esp
test eax, eax
jnz got_full_path

invoke MessageBoxEx, 0, ErrorInternalNoFullPath, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke ExitProcess, EXIT_NOFULLPATH

got_full_path:
mov eax, [esp]
mov [eax], BYTE 0
add esp, 4+MAX_PATH
invoke SetCurrentDirectory, esp
test eax, eax
jnz current_dir_set

invoke MessageBoxEx, 0, ErrorInternalNoSetCurDir, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke ExitProcess, EXIT_NOSETCURDIR

current_dir_set:
add esp, MAX_PATH
;Checking library version
invoke GetLibVersionAlpha
cmp eax, NEEDED_LIB_VERSION
je lib_version_correct

invoke MessageBoxEx, 0, ErrorWrongLib, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke ExitProcess, EXIT_WRONGLIB

lib_version_correct:
;Launching GECK
mov [ThreadSecurityAttributes.nLength], sizeof.SECURITY_ATTRIBUTES
mov [ThreadSecurityAttributes.lpSecurityDescriptor], 0
mov [ThreadSecurityAttributes.bInheritHandle], TRUE
invoke GetStartupInfo, OurStartupInfo
invoke CreateProcess, GECKFileName, 0, 0, ThreadSecurityAttributes, TRUE, CREATE_SUSPENDED, 0, 0, OurStartupInfo, GECKProcessInfo
test eax, eax
jnz noerror_1

invoke MessageBoxEx, 0, ErrorNoGECK, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke ExitProcess, EXIT_NOGECK

noerror_1:
invoke VirtualAllocEx, [GECKProcessInfo.hProcess], 0, injection_end - injection_start, \
	MEM_RESERVE + MEM_COMMIT, PAGE_EXECUTE_READWRITE
test eax, eax
jnz noerror_2

invoke MessageBoxEx, 0, ErrorNoAlloc, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke MessageBoxEx, 0, ErrorNoCleanup, ErrorCaption, MB_OK + MB_ICONEXCLAMATION, LANG
invoke ExitProcess, EXIT_NOALLOC

;This is the code injected into GECK
injection_start:
call next
db "geckpu-nv-14.dll", 0
next:	;esp contains address of the library name
mov eax, 00D2318Ch	;        00D2218Ch      ;LoadLibraryA
call DWORD [eax]
call next2
db "ApplyPatch", 0
next2:	;esp contains the procedure name
push eax	;Library handle
mov eax, 00D2317Ch	 ;      00D2217Ch      ;GetProcAddress
call DWORD [eax]
push DWORD NEED_NVSE
call DWORD eax
mov [ORIGINAL_ENTRY_POINT+1], DWORD ORIGINAL_ENTRY_CALL_OFFSET
mov [esp], DWORD ORIGINAL_ENTRY_POINT
retn
injection_end:

noerror_2:
add esp, 4	;We don't need the ThreadProc parameter
mov [pGeckMem], eax
invoke WriteProcessMemory, [GECKProcessInfo.hProcess], [pGeckMem], injection_start, injection_end - injection_start, 0
test eax, eax
jnz noerror_3

invoke MessageBoxEx, 0, ErrorNoWrite, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke MessageBoxEx, 0, ErrorNoCleanup, ErrorCaption, MB_OK + MB_ICONEXCLAMATION, LANG
invoke ExitProcess, EXIT_NOWRITE

noerror_3:
;Now we replace the instruction at the entry point
;Because using CreateRemoteThread leads to incompatibility with Win XP, don't know why
invoke VirtualProtectEx, [GECKProcessInfo.hProcess], ORIGINAL_ENTRY_POINT+1, 4, PAGE_EXECUTE_READWRITE, OldProtection
test eax, eax
jnz noerror_set_protection

invoke MessageBoxEx, 0, ErrorNoSetProtection, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke MessageBoxEx, 0, ErrorNoCleanup, ErrorCaption, MB_OK + MB_ICONEXCLAMATION, LANG
invoke ExitProcess, EXIT_NOSETPROTECTION

noerror_set_protection:
mov eax, [pGeckMem]
sub eax, ORIGINAL_ENTRY_POINT+5 ;Length of the command
push eax
mov eax, esp
invoke WriteProcessMemory, [GECKProcessInfo.hProcess], ORIGINAL_ENTRY_POINT+1, eax, 4, 0
add esp, 4
test eax, eax
jnz noerror_4

invoke MessageBoxEx, 0, ErrorNoChangeEntry, ErrorCaption, MB_OK + MB_ICONERROR, LANG
invoke MessageBoxEx, 0, ErrorNoCleanup, ErrorCaption, MB_OK + MB_ICONEXCLAMATION, LANG
invoke ExitProcess, EXIT_NOCHANGEENTRY

noerror_4:
;We can go now
invoke ResumeThread, [GECKProcessInfo.hThread]
invoke CloseHandle, [GECKProcessInfo.hThread]
invoke CloseHandle, [GECKProcessInfo.hProcess]
invoke ExitProcess, EXIT_OK


section '.idata' import data readable
library kernel, 'kernel32.dll', user, 'user32.dll', geckpu, 'geckpu-nv-14.dll'
import kernel, \
	GetModuleFileName, 'GetModuleFileNameA',\
	GetFullPathName, 'GetFullPathNameA',\
	SetCurrentDirectory, 'SetCurrentDirectoryA',\
	CreateProcess, 'CreateProcessA',\
	ExitProcess, 'ExitProcess',\
	VirtualAllocEx, 'VirtualAllocEx',\
	WriteProcessMemory, 'WriteProcessMemory',\
	CloseHandle, 'CloseHandle',\
	GetStartupInfo, 'GetStartupInfoA',\
	ResumeThread, 'ResumeThread',\
	WaitForSingleObject, 'WaitForSingleObject',\
	VirtualProtectEx, 'VirtualProtectEx'
import user, \
	MessageBoxEx, 'MessageBoxExA'
import geckpu, GetLibVersionAlpha, 'GetLibVersionAlpha'


section '.reloc' fixups data readable


section '.rsrc' resource data readable
	directory RT_VERSION, versions
	resource versions, 1, LANG_ENGLISH + SUBLANG_DEFAULT, vinfo
	versioninfo vinfo, VOS__WINDOWS32, VFT_APP, VFT2_UNKNOWN,\
		LANG_ENGLISH + SUBLANG_DEFAULT, 0,\
		'FileDescription', 'The G.E.C.K. 1.4 PowerUp NV Loader',\
		'FileVersion', '0.1.6',\
		'ProductName', 'The G.E.C.K. 1.4 PowerUp for Fallout: New Vegas',\
		'ProductVersion', '0.1.7.2'