;The G.E.C.K. PowerUp for New Vegas - Part of the library
;Spell checker patch (allows to enable and disable it)
;File version 0.1.2 (ported from GECK-PU-FO3 ver. 0.1.1.0)
;Written by Fedor Uvarov, 2010
;Patched to support G.E.C.K 1.4 by H. LE PORS ( 7 July 2011)

PATCH_SPELLCHECK_OFFSET = 0041B60Dh	;       0041B99Dh     ;       0041B88Dh
PATCH_SPELLCHECK_LENGTH = 13d
PATCH_SPELLCHECK_RETURN_SKIP = 0041B61Ah	;       0041B9AAh        ;       0041B89Ah


macro SPELLCHECK_DATA {
	AddrOf_Normal_SpellCheck dd ?
	bSpellCheckEnabled db 1
	SpellCheckName db "Enable spell checker", 0
	EndOf_SpellCheckName:
}

macro SPELLCHECK_PATCHES {
	stdcall MakeMemWriteable, PATCH_SPELLCHECK_OFFSET, PATCH_SPELLCHECK_LENGTH
	;call dword ptr ds:[<GetDlgItem>] -> mov eax, Callback_SpellCheck
	mov [PATCH_SPELLCHECK_OFFSET], BYTE 0B8h
	mov [PATCH_SPELLCHECK_OFFSET+1], DWORD Callback_SpellCheck
	;<extra byte> + push eax -> call eax
	mov [PATCH_SPELLCHECK_OFFSET+5], WORD 0D0FFh
	call RestoreMemProtection
}

macro SPELLCHECK_CALLBACKS {
	Callback_SpellCheck:
	;We're supposed to be GetDlgItem.
	;Later we must either push our result and return or
	;return to a different address (cleaning up 1 extra DWORD in stack)
	cmp [bSpellCheckEnabled], 0
	je .quit_function
	
	mov eax, esp
	push DWORD [eax+8]
	push DWORD [eax+4]
	invoke GetDlgItem
	mov DWORD [esp+8], eax
	retn 4
	
	.quit_function:
	mov [esp], DWORD PATCH_SPELLCHECK_RETURN_SKIP
	retn 12
}

;When this macro is inserted, there is MENUITEMINFO structure in the stack
;and hMainMenu contains main menu handle.
macro SPELLCHECK_MAINMENU {
	SPELLCHECK_MAINMENU:
	mov [esp+MII_fMask], DWORD MIIM_FTYPE + MIIM_ID
	mov [esp+MII_fType], DWORD MFT_SEPARATOR	;fType
	mov [esp+MII_wID], DWORD MENU_OBJECTLISTCOLS_SEP
	invoke InsertMenuItem, [hMainMenu], MENU_OLD_OBJECTLISTCOLS, 0, esp
	mov [esp+MII_fMask], DWORD MIIM_STRING + MIIM_ID + MIIM_FTYPE + MIIM_CHECKMARKS + MIIM_STATE
	mov [esp+MII_fType], DWORD MFT_STRING
	mov [esp+MII_fState], DWORD MFS_CHECKED ;fState
	mov [esp+MII_wID], DWORD MENU_SPELLCHECK
	mov [esp+MII_dwTypeData], DWORD SpellCheckName
	mov [esp+MII_cch], DWORD EndOf_SpellCheckName - SpellCheckName	;sizeof SpellCheckName
	invoke InsertMenuItem, [hMainMenu], MENU_OBJECTLISTCOLS_SEP, FALSE, esp
	test eax, eax
	jnz .noerror
	call PatchAbort
	.noerror:
}

macro SPELLCHECK_MENUCOMMAND_SPELLCHECK {
	SPELLCHECK_MENUCOMMAND_SPELLCHECK:
	MakeMENUITEMINFO
	mov [esp+MII_fMask], DWORD MIIM_STATE
	.if [bSpellCheckEnabled] = 1
		mov [esp+MII_fState], DWORD MFS_UNCHECKED
		mov [bSpellCheckEnabled], 0
	.else
		mov [esp+MII_fState], DWORD MFS_CHECKED
		mov [bSpellCheckEnabled], 1
	.endif
	invoke SetMenuItemInfo, [hMainMenu], MENU_SPELLCHECK, 0, esp
	add esp, sizeof.MENUITEMINFO + 4
}